"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Pagination = void 0;
var react_1 = __importStar(require("react"));
var Noop = function (_a) {
    var children = _a.children;
    return react_1.default.createElement("a", null, children);
};
var Pagination = function (_a) {
    var _b = _a.pageInVisible, pageInVisible = _b === void 0 ? 10 : _b, _c = _a.hideOnSinglePage, hideOnSinglePage = _c === void 0 ? true : _c, _d = _a.wrapClassName, wrapClassName = _d === void 0 ? 'infinite-pagination' : _d, _e = _a.itemClassName, itemClassName = _e === void 0 ? 'infinite-pagination-item' : _e, _f = _a.renderPageItem, ItemPage = _f === void 0 ? Noop : _f, _g = _a.renderPrev, PrevPage = _g === void 0 ? Noop : _g, _h = _a.renderNext, NextPage = _h === void 0 ? Noop : _h, props = __rest(_a, ["pageInVisible", "hideOnSinglePage", "wrapClassName", "itemClassName", "renderPageItem", "renderPrev", "renderNext"]);
    var mountedRef = react_1.useRef(false);
    var lastPage = react_1.useMemo(function () {
        var lastPage = props.lastPage;
        if (typeof lastPage !== 'number') {
            return undefined;
        }
        if (lastPage < 0 || !lastPage) {
            return undefined;
        }
        return lastPage;
    }, [props.lastPage]);
    var initialStateFn = react_1.useCallback(function () {
        var _a;
        var current = Math.max(1, (_a = props.current) !== null && _a !== void 0 ? _a : 1);
        if (lastPage) {
            return Math.min(lastPage, current);
        }
        return current;
    }, [props.current, lastPage]);
    var _j = react_1.useState(initialStateFn), current = _j[0], setCurrent = _j[1];
    var pages = react_1.useMemo(function () {
        var left = false;
        var pages = [current];
        while (pages.length < pageInVisible) {
            var _a = pages, first = _a[0], l = _a.length, _b = l - 1, last = _a[_b];
            if (!left && first > 1) {
                pages.unshift(first - 1);
                left = true;
            }
            else {
                if (lastPage === undefined || last < lastPage) {
                    pages.push(last + 1);
                    left = false;
                }
                else {
                    if (first > 1) {
                        pages.unshift(first - 1);
                    }
                    else {
                        break;
                    }
                }
            }
        }
        return pages;
    }, [current, lastPage, pageInVisible]);
    function handleSelectPage(page, isPrevent) {
        return function (e) {
            e.preventDefault();
            if (isPrevent) {
                return;
            }
            setCurrent(page);
        };
    }
    function handleEnterSelectPage(page, isPrevent) {
        return function (e) {
            if (isPrevent) {
                return;
            }
            if (e.key === 'Enter') {
                setCurrent(page);
            }
        };
    }
    react_1.useEffect(function () {
        if (mountedRef.current === false) {
            mountedRef.current = true;
        }
    }, []);
    react_1.useEffect(function () {
        var _a;
        if (mountedRef.current) {
            (_a = props.onChange) === null || _a === void 0 ? void 0 : _a.call(props, current);
        }
    }, [current, props.onChange]);
    react_1.useEffect(function () {
        if (mountedRef.current) {
            setCurrent(initialStateFn);
        }
    }, [initialStateFn]);
    function renderPage(page) {
        var disable = page === current;
        return (react_1.default.createElement("li", { key: page, className: itemClassName + " " + (disable ? 'active' : ''), onClick: handleSelectPage(page, disable), onKeyDown: handleEnterSelectPage(page, disable), tabIndex: 0 },
            react_1.default.createElement(ItemPage, { page: page }, page)));
    }
    function renderPrev() {
        var disable = current <= 1;
        return (react_1.default.createElement("li", { className: "" + itemClassName + (disable ? ' disable' : ''), onClick: handleSelectPage(current - 1, disable), onKeyDown: handleEnterSelectPage(current - 1, disable), "aria-disabled": disable, tabIndex: 0 },
            react_1.default.createElement(PrevPage, { page: current - 1 }, "prev")));
    }
    function renderNext() {
        var disable = lastPage !== undefined && current >= lastPage;
        return (react_1.default.createElement("li", { className: "" + itemClassName + (disable ? ' disable' : ''), onClick: handleSelectPage(current + 1, disable), onKeyDown: handleEnterSelectPage(current + 1, disable), "aria-disabled": disable, tabIndex: 0 },
            react_1.default.createElement(NextPage, { page: current + 1 }, "next")));
    }
    return false === hideOnSinglePage || pages.length > 1 ? (react_1.default.createElement("nav", { className: wrapClassName, role: 'navigation' },
        react_1.default.createElement("ul", { unselectable: 'on' },
            renderPrev(),
            pages.map(renderPage),
            renderNext()))) : null;
};
exports.Pagination = Pagination;
